package forestry.api.arboriculture;

import forestry.api.genetics.IAllele;
import forestry.api.genetics.IChromosome;
import net.minecraft.src.ItemStack;
import net.minecraft.src.World;

public interface ITreeInterface {
	boolean isGermling(ItemStack itemstack);

	boolean isPollen(ItemStack itemstack);

	boolean isPollinated(ItemStack itemstack);

	ITree getTree(ItemStack itemstack);

	ITree getTree(World world, ITreeGenome genome);

	ItemStack getGermlingStack(ITree tree, EnumGermlingType type);

	boolean plantSapling(World world, ITree tree, int x, int y, int z);

	IChromosome[] templateAsChromosomes(IAllele[] template);

	IChromosome[] templateAsChromosomes(IAllele[] templateActive, IAllele[] templateInactive);

	ITreeGenome templateAsGenome(IAllele[] template);

	ITreeGenome templateAsGenome(IAllele[] templateActive, IAllele[] templateInactive);

	boolean setLeaves(World world, ITree tree, int x, int y, int z);
}
